%%            Operational Mode

%% This script finds the operational mode for the shuttle tanker for
%% each AIS message

for i = 1:size(res2,2)
    
  
    
    %% Offloadin operation
    for j = 1:size(res2(i).approach15,1)
        if table2array(res2(i).approach15(j,7)) <0.6/60
            res2(i).PosInfo(table2array(res2(i).approach15(j,13))).Operation = 'Offloading Operation';
        else
            res2(i).PosInfo(table2array(res2(i).approach15(j,13))).Operation = 'Transit';
        end
    end
    
    %% Port
    for j = 1:size(res2(i).coast,1)
        if table2array(res2(i).coast(j,7)) < 0.5/60
            res2(i).PosInfo(table2array(res2(i).coast(j,13))).Operation = 'Port';
        elseif table2array(res2(i).coast(j,7)) > 0.5/60
            res2(i).PosInfo(table2array(res2(i).coast(j,13))).Operation = 'Transit';
        end
    end
    
    %% Waiting
    for j = 1:size(res2(i).PosInfo,2)
        if isempty(res2(i).PosInfo(j).Operation) == 1
            if table2array(res2(i).results(j,10)) < 1/60
                res2(i).PosInfo(j).Operation = 'Waiting';
            else
                res2(i).PosInfo(j).Operation = 'Transit';
            end
        end
    end
    
    
    %% If NAN values, the operation is same as last.
    for j = 1:size(res2(i).results,1)
        if isnan(table2array(res2(i).results(j,10))) == 1
            res2(i).PosInfo(j).Operation = res2(i).PosInfo(j-1).Operation;
        end
    end

            
    
end

%% Estimate the loading condition of the shuttle tanker 
for i = 1:size(res2,2)

  
    
    %% Find initial loading condition 
    for j = 1:size(res2(i).PosInfo,2)
            
        if strcmp([res2(i).PosInfo(j).Operation],'Offloading Operation') == 1
            transitMode = 'Ballast';
            break
        elseif strcmp([res2(i).PosInfo(j).Operation],'Port') == 1
            transitMode = 'Laden';
            break
        end
    end
    
    %% Determine the loading condition
    for j = 1:size(res2(i).PosInfo,2)
        if strcmp([res2(i).PosInfo(j).Operation],'Transit') == 1
            res2(i).PosInfo(j).Transit = transitMode;
        elseif strcmp([res2(i).PosInfo(j).Operation],'Waiting') == 1
            res2(i).PosInfo(j).Transit = transitMode;
        %% Change to ballast condition if it is at port
        elseif strcmp([res2(i).PosInfo(j).Operation],'Port') == 1
            transitMode = 'Ballast';
        %% Change to laden condition if it loads oil
        elseif strcmp([res2(i).PosInfo(j).Operation],'Offloading Operation') == 1
            transitMode = 'Laden';
        
        end
    end
    
 %% If it is in laden condition and leaves for more than 48 hours it is 
 %% assumed that it unloads at a European port
 
    changeMode = 0;
    for j = 2:size(res2(i).results,1)
        waitbar(j/size(res2(i).results,1))
        
       
        if strcmp([res2(i).PosInfo(j).Transit],'Laden') == 1 &&...
                days(datetime(table2array(res2(i).results(j,4)))-...
                datetime(table2array(res2(i).results(j-1,4)))) > 2
            
            res2(i).PosInfo(j).Transit = 'Ballast';
            changeMode = 1;
            
        elseif strcmp([res2(i).PosInfo(j).Operation],'Offloading Operation')
            changeMode = 0;
            
            
        elseif strcmp([res2(i).PosInfo(j).Transit],'Laden') == 1 &&...
                changeMode == 1
            res2(i).PosInfo(j).Transit = 'Ballast';
        end
    end
%%
            
        
        
        
end        
