%%                    Close to shore

%% This script extracts all AIS messages close to shore and determines if
%% the vessel is in port

%% NB! Long computational time

%% Import coastline coordinates
coastpointss = load('coast.mat'); % load long and lat data coast


%% Limit the data to Norwegian waters
SW = [55 0];
NE = [75 40];
counter = 1;

%% Extract coastline coordinates that comply with the limitation
for i = 1:size(coastpointss.lat,1)
    waitbar(i/size(coastpointss.lat,1))
    if coastpointss.lat(i) >= SW(1) && coastpointss.lat(i) <= NE(1) && coastpointss.long(i) <= NE(2) && coastpointss.long(i) >= SW(2)
        
        coastpointss.NorwayLat(counter,1) = coastpointss.lat(i);
        coastpointss.NorwayLong(counter,1) = coastpointss.long(i);
        counter = counter + 1;
    end
end


%% Plot map projection of the extracted coordinates
geoshow(coastpointss.NorwayLat,coastpointss.NorwayLong,'DisplayType','point')

%% Import referance elipsoid
elip = referenceEllipsoid('earth');


h = waitbar(0,'nearcoast');

%% Extract the AIS messages that are within 30 km of a coastline coordinate

for i = 1:size(res2,2)
    res2(i).coast=table;
    
    tab = 1;

    for y = 1:size(res2(i).results,1)
        waitbar(y/size(res2(i).results,1))
        
        dist = 10000000; %Large dummy variable
        
        for k = 1:size(coastpointss.NorwayLat,1)
            if distance(coastpointss.NorwayLat(k),coastpointss.NorwayLong(k),table2array(res2(i).results(y,16)),table2array(res2(i).results(y,15)),elip)/1000 <= 30 
                if distance(coastpointss.NorwayLat(k),coastpointss.NorwayLong(k),table2array(res2(i).results(y,16)),table2array(res2(i).results(y,15)),earthR) < dist
                    dist = distance(coastpointss.NorwayLat(k),coastpointss.NorwayLong(k),table2array(res2(i).results(y,16)),table2array(res2(i).results(y,15)),earthR);
                    index = k;
                end
                
            end
        end
        
        if dist < 10000000
            
            res2(i).coast(tab,:) = [res2(i).results(y,4:11) res2(i).results(y,15:16) {dist} {index} {y}];
            tab = tab + 1;
        end
            
    end
                
    %% Apply headers   
%     res2(i).coast.Properties.VariableNames{11} = 'Dist_to_shorepoint';
%     res2(i).coast.Properties.VariableNames{12} = 'shore_lat_long';
%     res2(i).coast.Properties.VariableNames{13} = 'dataposition';
end
