%%  Offloading Operation data extraction
%% This script extracts the AIS messages that correspond to offloading operations


%% Import installation data from spreadsheet
% Script for importing data from the following spreadsheet:
%
%    Workbook: C:\Users\langd\Documents\Skole\Master\Data - Kystverket\FPSO_Norge.xlsx
%    Worksheet: Ark1
%
% To extend the code for use with different selected data or a different
% spreadsheet, generate a function instead of a script.

% Auto-generated by MATLAB on 2017/05/10 19:29:57

%% Import the data
[~, ~, raw] = xlsread('C:\Users\langd\Documents\Skole\Master\Data - Kystverket\Thesis material\FPSO_Norge.xlsx','Ark1','A1:C17');
raw(cellfun(@(x) ~isempty(x) && isnumeric(x) && isnan(x),raw)) = {''};
cellVectors = raw(2:end,1);
raw = raw(2:end,[2,3]);

%% Create output variable
data = reshape([raw{:}],size(raw));

%% Create table
FPSO = table;

%% Allocate imported array to column variable names
FPSO.FPSO = cellVectors(:,1);
FPSO.lat = data(:,1);
FPSO.long = data(:,2);

elip = referenceEllipsoid('earth');
coordinates2 = [FPSO.lat FPSO.long];
%%
for i = 1:size(res2,2)
  
    tab = 1;
    res2(i).approach15=table;
    
    if mod(i,10) == 0
        sprintf('%i',i)
    end
    
    for y = 1:size(res2(i).results,1)
       
        %% Measure the distance between the AIS message and the installations
        %% Calculate distance and note which installation, and which AIS message
        for k = 1:size(FPSO,1)
            %% If it is within 1.5km of an installation
            if distance(coordinates2(k,1),coordinates2(k,2),table2array(res2(i).results(y,16)),table2array(res2(i).results(y,15)),elip)/1000 <= 1.5 %checks if the vessel is within 1500m of an installation
                res2(i).approach15(tab,:) = [res2(i).results(y,4:11) res2(i).results(y,15:16) array2table(distance(coordinates2(k,1),coordinates2(k,2),table2array(res2(i).results(y,16)),table2array(res2(i).results(y,15)),elip)/1000) FPSO.FPSO(k) {y}];
                tab = tab + 1;
            end
        end
        tab = size(res2(i).approach15,1) + 1;
    end
    
    
    %% Apply headers
    if isempty(res2(i).approach15) == 0
         res2(i).approach15.Properties.VariableNames{11} = 'Dist_to_inst';
         res2(i).approach15.Properties.VariableNames{12} = 'Installation';
         res2(i).approach15.Properties.VariableNames{13} = 'dataposition';
         
    end
end

%% Sorts the offloading operations data into seperate tables
%% for each specific offloading operation.

for i = 1:size(res2,2)
    
    counter = 1;
    FPSOcounter = 0;
    
 
        for j = 1:size(res2(i).approach15,1)
            name = cell2mat(table2array(res2(i).approach15(j,12)));
            

            if j >= 2 && strcmp(cell2mat(table2array(res2(i).approach15(j,12))),...
                    cell2mat(table2array(res2(i).approach15(j - 1,12))))== 1 ...
                    && table2array(res2(i).approach15(j,13)) == table2array(res2(i).approach15(j-1,13)) + 1
                
                counter = counter + 1;
                res2(i).OP(FPSOcounter).instdata(counter,:) = res2(i).approach15(j,:);
               
            else
               
                counter = 1;
                FPSOcounter = FPSOcounter + 1;
                res2(i).OP(FPSOcounter).instdata(counter,:) = res2(i).approach15(j,:);
                res2(i).OP(FPSOcounter).name = table2array(res2(i).approach15(j,12));
            end
        end
end

                
                