%%                    Results

%% This script calculates the results from the heuristic analysis

%% Operational profile (total hours)
P = zeros(31,6);

vessel = 1; % Choose vessel i (1-33) that is analysed 

for i = vessel 
   
    P(i,1) = i;
    for j = 1:size(res2(i).PosInfo,2) 
        
        if strcmp(res2(i).PosInfo(j).Operation,'Offloading Operation') == 1
            P(i,2) = P(i,2) + table2array(res2(i).results(j,11));
        elseif strcmp(res2(i).PosInfo(j).Operation,'Transit') == 1
            if strcmp(res2(i).PosInfo(j).Transit,'Ballast') == 1
                P(i,3) = P(i,3) + table2array(res2(i).results(j,11));
            elseif strcmp(res2(i).PosInfo(j).Transit,'Laden') == 1
                P(i,4) = P(i,4) + table2array(res2(i).results(j,11));
            end
            
        elseif strcmp(res2(i).PosInfo(j).Operation,'Waiting') == 1
            P(i,5) = P(i,5) + table2array(res2(i).results(j,11));
        elseif strcmp(res2(i).PosInfo(j).Operation,'Port') == 1
            P(i,6) = P(i,6) + table2array(res2(i).results(j,11));
            
            
            
        end
    end
    


%% Operational profile (%)
PP = zeros(31,5);
    for j = 2:6
        PP(i,j) = P(i,j)/sum(P(i,2:6));
    end



%% Laden or ballast
Laden = 0;
Ballast = 0;

for j = size(res2(i).PosInfo,2) 
    if strcmp([res2(i).PosInfo(j).Transit],'Laden') == 1
        Laden = Laden + table2array(res2(i).results(j,11));
    elseif strcmp([res2(i).PosInfo(j).Transit],'Ballast') == 1
        Ballast = Ballast + table2array(res2(i).results(j,11));
    end
end





%% Calculate CO2 emissions 
E = zeros(31,6);

E(i,1) = i;
    for j = 1:size(res2(i).PosInfo,2)
        
        if strcmp(res2(i).PosInfo(j).Operation,'Offloading Operation') == 1
            E(i,2) = E(i,2) + nansum(table2array(res2(i).results(j,7)));
        elseif strcmp(res2(i).PosInfo(j).Operation,'Transit') == 1
            if strcmp(res2(i).PosInfo(j).Transit,'Ballast') == 1
                E(i,3) = E(i,3) + nansum(table2array(res2(i).results(j,7)));
            elseif strcmp(res2(i).PosInfo(j).Transit,'Laden') == 1
                E(i,4) = E(i,4) + nansum(table2array(res2(i).results(j,7)));
            end
            
        elseif strcmp(res2(i).PosInfo(j).Operation,'Waiting') == 1
            E(i,5) = E(i,5) + nansum(table2array(res2(i).results(j,7)));
        elseif strcmp(res2(i).PosInfo(j).Operation,'Port') == 1
            E(i,6) = E(i,6) + nansum(table2array(res2(i).results(j,7)));
            

            
        end
    end
    

            
%% Calculate fuel consumption
F = zeros(31,6);

F(i,1) = i;
    for j = 1:size(res2(i).PosInfo,2) %8731:63073           % 
        
        if strcmp(res2(i).PosInfo(j).Operation,'Offloading Operation') == 1
            F(i,2) = F(i,2) + nansum(table2array(res2(i).results(j,5)));
        elseif strcmp(res2(i).PosInfo(j).Operation,'Transit') == 1
            if strcmp(res2(i).PosInfo(j).Transit,'Ballast') == 1
                F(i,3) = F(i,3) + nansum(table2array(res2(i).results(j,5)));
            elseif strcmp(res2(i).PosInfo(j).Transit,'Laden') == 1
                F(i,4) = F(i,4) + nansum(table2array(res2(i).results(j,5)));
            end
            
        elseif strcmp(res2(i).PosInfo(j).Operation,'Waiting') == 1
            F(i,5) = F(i,5) + nansum(table2array(res2(i).results(j,5)));
        elseif strcmp(res2(i).PosInfo(j).Operation,'Port') == 1
            F(i,6) = F(i,6) + nansum(table2array(res2(i).results(j,5)));
            

            
        end
    end
    

end


    
    